package com.wdkl.ncs.android.component.home.activity

import android.graphics.Color
import android.util.Log
import com.enation.javashop.net.engine.model.NetState
import com.wdkl.ncs.android.component.home.R
import com.wdkl.ncs.android.component.home.databinding.ActivityNetworkCheckBinding
import com.wdkl.ncs.android.component.home.launch.HomeLaunch
import com.wdkl.ncs.android.component.home.util.PingUtil
import com.wdkl.ncs.android.lib.base.BaseApplication
import com.wdkl.ncs.android.lib.utils.showMessage
import com.wdkl.ncs.android.lib.vo.MessageEvent
import com.wdkl.ncs.android.middleware.logic.contract.home.WatchHomeActivityContract
import com.wdkl.ncs.android.middleware.logic.presenter.home.WatchHomeActivityPresenter
import com.wdkl.ncs.android.middleware.model.ServerIpInfo
import com.wdkl.ncs.android.middleware.model.dos.AppVersionDO
import com.wdkl.ncs.android.middleware.model.dos.ChannelDO
import com.wdkl.ncs.android.middleware.model.dos.PartSettingDO
import com.wdkl.ncs.android.middleware.model.dto.TcpSeverDTO
import com.wdkl.ncs.android.middleware.model.vo.DeviceVO
import com.wdkl.ncs.android.middleware.model.vo.WatchContactVO
import com.wdkl.ncs.android.middleware.utils.CommonUtils
import kotlinx.android.synthetic.main.activity_network_check.*
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode

class NetworkCheckActivity: BaseActivity<WatchHomeActivityPresenter, ActivityNetworkCheckBinding>(), WatchHomeActivityContract.View {
    private var clickTime: Long = 0

    var builder = StringBuilder()

    override fun getLayId(): Int {
        return R.layout.activity_network_check
    }

    override fun bindDagger() {
        HomeLaunch.component.inject(this)
    }

    override fun init() {
        tv_check_host_ip.setText("Host IP: " + CommonUtils.getUrl(this))

        Thread {
            PingUtil.setCallback(object : PingUtil.PingCallback {
                override fun onPingInfo(info: String?) {
                    updatePingInfo("ping result: $info")
                }

                override fun onPingResult(rtt: Int, lostRate: Float) {
                    updatePingInfo("RTT: $rtt, LostRate: $lostRate")
                }
            })

            //val result = PingUtil.parseRTT(CommonUtils.getUrl(BaseApplication.appContext), PingUtil.TYPE_AVG, 10, 100);
            val result = PingUtil.parseRTT(CommonUtils.getUrl(BaseApplication.appContext))
            Log.d("ping", "check result: $result")
            updatePingResult(result)
        }.start()
    }

    private fun updatePingInfo(info: String) {
        builder.append(info)
        runOnUiThread {
            tv_check_net_info.setText(builder.toString())
        }
    }

    private fun updatePingResult(result: String) {
        runOnUiThread {
            /*if (PingUtil.RESULT_BAD == result) {
                tv_check_net_result.setTextColor(Color.RED)
            } else if (PingUtil.RESULT_NORMAL == result) {
                tv_check_net_result.setTextColor(Color.YELLOW)
            } else if (PingUtil.RESULT_GOOD == result) {
                tv_check_net_result.setTextColor(Color.GREEN)
            }
            tv_check_net_result.setText(result)*/

            tv_check_net_result.setTextColor(Color.RED)
            tv_check_net_result.setText("Check complete")
        }
    }

    override fun bindEvent() {
        //
    }

    override fun destory() {
        //
    }

    override fun enableHeadsetVoiceMsg(): Boolean {
        return false
    }

    override fun handleAppVersion(appInfo: AppVersionDO) {
    }

    override fun setDeviceDo(data: DeviceVO) {
    }

    override fun setTcpServerHost(tcpSeverDTO: TcpSeverDTO) {
    }

    override fun setServerInfo(serverIpInfo: ServerIpInfo) {
    }

    override fun setDeviceSettingData(partSettingDO: PartSettingDO) {
    }

    override fun setDeviceVoiceChannel(channelList: ArrayList<ChannelDO>) {
    }

    override fun setPhoneNumberWhiteList(phoneList: ArrayList<String>) {
    }

    override fun setContact(contactsVOs: List<WatchContactVO>) {

    }

    override fun onBackPressed() {
        if (System.currentTimeMillis() - clickTime > 2000) {
            showMessage(R.string.click_twice_to_back)
        } else {
            super.onBackPressed()
        }
        clickTime = System.currentTimeMillis()
    }

    override fun onError(message: String, type: Int) {
        showMessage(message)
    }

    override fun complete(message: String, type: Int) {

    }

    override fun start() {

    }

    override fun networkMonitor(state: NetState) {

    }


    @Subscribe(threadMode = ThreadMode.MAIN)
    fun onMoonEvent(messageEvent: MessageEvent) {
        //
    }
}