package com.wdkl.ncs.android.component.home.broadcast;

import android.annotation.SuppressLint;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.widget.TextView;

import com.wdkl.ncs.android.component.home.R;
import com.wdkl.ncs.android.component.home.settingconfig.SettingConfig;
import com.wdkl.ncs.android.component.home.util.LocaleMangerUtils;
import com.wdkl.ncs.android.component.home.util.RingPlayHelper;
import com.wdkl.ncs.android.component.home.util.SpeechUtil;
import com.wdkl.ncs.android.middleware.common.Constants;
import com.wdkl.ncs.android.lib.vo.MessageEvent;

import org.greenrobot.eventbus.EventBus;

import java.util.Locale;


public class BatteryBroadcastReceiver extends BroadcastReceiver {
    private String TAG = BatteryBroadcastReceiver.class.getSimpleName();

    private TextView mBatteryView;

    public BatteryBroadcastReceiver(TextView mBatteryView) {
        this.mBatteryView = mBatteryView;
    }

    @SuppressLint("LongLogTag")
    @Override
    public void onReceive(Context context, Intent intent) {
        if (Intent.ACTION_BATTERY_CHANGED.equals(intent.getAction())) {
            int level = intent.getIntExtra("level", 0);
            int scale = intent.getIntExtra("scale", 100);
            int power = level * 100 / scale;
            if (power<15){
                if (Constants.Companion.getEVENT_BATTERY_ALARM()) {
                    String language = LocaleMangerUtils.getApplicationLocale().getLanguage();
                    if (Locale.CHINESE.getLanguage().equals(language)) {
                        SpeechUtil.getInstance().newSpeech("电池电量低，请注意!电池电量低，请注意!电池电量低，请注意!", false);
                    } else {
                        RingPlayHelper.playRingTone(context, R.raw.low_battery, false);
                    }
                    Constants.Companion.setEVENT_BATTERY_ALARM(false);
                }
            } else {
                Constants.Companion.setEVENT_BATTERY_ALARM(true);
            }
            EventBus.getDefault().post(new MessageEvent(power, Constants.EVENT_BATTERY_PERCENT));
        }
    }
}
