package com.wdkl.ncs.android.component.home.util

import android.annotation.SuppressLint
import android.util.Log
import com.wdkl.ncs.android.middleware.common.Constants
import com.wdkl.ncs.android.lib.utils.showMessage
import com.wdkl.ncs.android.lib.vo.MessageEvent
import com.wdkl.ncs.android.middleware.tcp.NettyClient
import org.greenrobot.eventbus.EventBus

class HandleTcpConnect {
    val TAG = HandleTcpConnect::class.simpleName

    /*伴生对象*/
    companion object {
        var instance = HandleTcpConnect()
    }

    @SuppressLint("CheckResult")
    fun tcpInitConnect(){
        Log.d(TAG, "TCP.开始初始连接")
        NettyClient.instance.connect(Constants.tcpServer, Constants.tcpPort, Constants.heartBeat.toLong()).subscribe {
            if (it){
                Log.d(TAG, "TCP.连接成功")
                EventBus.getDefault().post(MessageEvent("tcp connected", Constants.EVENT_TCP_CONNECTED))
            } else {
                Log.e(TAG, "TCP.连接失败")
                EventBus.getDefault().post(MessageEvent("tcp connected", Constants.EVENT_TCP_BREAK))
            }
        }
    }

    @SuppressLint("CheckResult")
    fun tcpReConnect(){
        Log.d(TAG, "TCP.开始重新连接")
        NettyClient.instance.reConnect().doOnError {
            it.message?.let { it1 -> Log.e(TAG, it1) }
        }.subscribe {
            if (it){
                Log.d(TAG, "TCP.重连成功")
            } else {
                Log.e(TAG, "TCP.重连失败")
            }
        }
    }

    @SuppressLint("CheckResult")
    fun tcpReConnectWithMsgShow(){
        Log.d(TAG, "TCP.开始重新连接")
        //showMessage("服务连接失败，正在重连")
        NettyClient.instance.reConnect().doOnError {
            it.message?.let { it1 -> Log.e(TAG, it1) }
        }.subscribe{
            if (it){
                Log.d(TAG, "服务重连成功")
                //EventBus.getDefault().post(MessageEvent("tcp connected", Constants.EVENT_TCP_CONNECTED))
                //showMessage("重连成功")
            } else {
                Log.d(TAG, "服务重连失败")
                //showMessage("重连失败，请尝试重启APP")
            }
        }
    }
}