package com.wdkl.ncs.android.component.home.util;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.SystemClock;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.Chronometer;
import android.widget.TextView;

import com.wdkl.ncs.android.component.home.R;

public class ImPlayDialogHelper {

    private static AlertDialog imPlayDialog;

    public static void showImPlayDialog(Activity activity, String text, String time) {
        View contentView = LayoutInflater.from(activity).inflate(R.layout.im_play_dialog_lay, null);
        AlertDialog.Builder builder = new AlertDialog.Builder(activity);
        builder.setView(contentView);

        Button confirm = contentView.findViewById(R.id.btn_im_stop);
        confirm.setOnClickListener(v -> {
            MediaPlayHelper.getInstance().stopMusic(false);
            dismissIMDialog();
        });
        TextView textView = contentView.findViewById(R.id.tv_im_play_name);
        textView.setText(text);
        TextView timeView = contentView.findViewById(R.id.tv_im_time);
        timeView.setText(time);
        Chronometer chronometer = contentView.findViewById(R.id.im_play_time);
        chronometer.setBase(SystemClock.elapsedRealtime());
        chronometer.start();


        imPlayDialog = builder.create();
        imPlayDialog.setCanceledOnTouchOutside(false);
        imPlayDialog.setCancelable(false);
        imPlayDialog.setOnDismissListener(new DialogInterface.OnDismissListener() {
            @Override
            public void onDismiss(DialogInterface dialog) {
                if (chronometer != null) {
                    chronometer.stop();
                }
            }
        });

        //设置dialog宽高及位置
        try {
            Window window = imPlayDialog.getWindow();
            window.setFlags(WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE, WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE);
            imPlayDialog.show();
            WindowManager.LayoutParams lp = window.getAttributes();
            lp.width = 580;
            lp.height = 540;
            lp.gravity = Gravity.CENTER;
            //lp.alpha = 0.8f;//设置透明度
            window.setAttributes(lp);

            window.clearFlags(WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void dismissIMDialog() {
        if (imPlayDialog != null && imPlayDialog.isShowing()) {
            imPlayDialog.dismiss();
        }
    }
}
