package com.wdkl.ncs.android.component.home.util;

import android.util.Log;

import com.wdkl.ncs.android.middleware.common.Constants;
import com.wdkl.ncs.android.middleware.api.UrlManager;
import com.wdkl.rtc.util.ILogUpload;

import java.io.IOException;

import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.FormBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

public class LogUpload implements ILogUpload {
    private final static String TAG = LogUpload.class.getSimpleName();
    private static OkHttpClient okHttpClient = new OkHttpClient();
    private static UrlManager urlManager = UrlManager.Companion.build();

    public void errorLog(String class_name, String err_msg, String method_name, String stack_trace) {

        FormBody.Builder formBody = new FormBody.Builder();
        formBody.add("device_id", ""+ Constants.Companion.getDeviceId());
        formBody.add("class_name",class_name);
        formBody.add("method_name",method_name);
        formBody.add("exception_name",TAG);
        formBody.add("err_msg",err_msg);
        formBody.add("stack_trace",stack_trace);
        Log.w(TAG,urlManager.getDevice_url());
        Request request  = new Request.Builder()
                .url(urlManager.getDevice_url() + "device/error_log")
                .post(formBody.build())
                .build();

        okHttpClient.newCall(request).enqueue(new Callback() {
            @Override
            public void onFailure(Call call, IOException e) {
                Log.e(TAG,"错误日志上传失败"+e.getMessage());
            }

            @Override
            public void onResponse(Call call, Response response) throws IOException {
                Log.d(TAG,"错误日志上传成功");
                String data = response.body().string();
                Log.d(TAG,"错误日志数据 data "+data);
            }
        });
    }
}
