package com.wdkl.ncs.android.component.home.util

import android.annotation.SuppressLint
import android.app.KeyguardManager
import android.content.Context
import android.content.Context.KEYGUARD_SERVICE
import android.os.PowerManager
import android.util.DisplayMetrics
import android.view.WindowManager
import com.wdkl.ncs.android.lib.base.BaseApplication


object Util {

    /**
     * 亮屏并解锁
     */
    @SuppressLint("InvalidWakeLockTag")
    fun wakeUpAndUnlock(): PowerManager.WakeLock? {
        val pm = BaseApplication.appContext.getSystemService(Context.POWER_SERVICE) as PowerManager
        var wakeLock: PowerManager.WakeLock? = null

        val screenOn = pm.isInteractive
        if (!screenOn) { //如果是熄灭状态
            wakeLock = pm.newWakeLock(PowerManager.ACQUIRE_CAUSES_WAKEUP or PowerManager.SCREEN_DIM_WAKE_LOCK, "TAG")
            wakeLock.acquire(10000)//亮屏
        }

        // 屏幕解锁
        val keyguardManager = BaseApplication.appContext.getSystemService(KEYGUARD_SERVICE) as KeyguardManager
        val keyguardLock = keyguardManager.newKeyguardLock("unLock")
        // 屏幕锁定
        keyguardLock.reenableKeyguard()
        keyguardLock.disableKeyguard() // 解锁
        return wakeLock
    }

    @SuppressLint("InvalidWakeLockTag")
    fun getCpuWakeLock(context: Context): PowerManager.WakeLock? {
        val pm = context.getSystemService(Context.POWER_SERVICE) as PowerManager
        val cpuWakeLock = pm.newWakeLock(PowerManager.PARTIAL_WAKE_LOCK,
                context.javaClass.canonicalName)
        return cpuWakeLock
    }

    fun appendSpace(para: String): String? {
        val length = para.length
        val value = CharArray(length shl 1)
        var i = 0
        var j = 0
        while (i < length) {
            value[j] = para[i]
            value[1 + j] = ' '
            ++i
            j = i shl 1
        }
        return String(value)
    }



    fun getPixelsFromDp(context: Context, size: Int): Int {
        val metrics = DisplayMetrics()
        val wm = context.getSystemService(Context.WINDOW_SERVICE) as WindowManager
        wm.getDefaultDisplay().getMetrics(metrics)
        return size * metrics.densityDpi / DisplayMetrics.DENSITY_DEFAULT
    }
}