package com.wdkl.ncs.android.component.home.activity

import android.app.Activity
import android.os.Bundle
import android.text.TextUtils
import android.text.method.ScrollingMovementMethod
import android.view.View
import com.wdkl.ncs.android.component.home.R
import com.wdkl.ncs.android.component.home.util.AppUtils
import com.wdkl.ncs.android.lib.utils.showMessage
import com.wdkl.ncs.android.middleware.common.Constants
import com.wdkl.ncs.android.middleware.tcp.NettyClient
import com.wdkl.ncs.android.middleware.tcp.channel.DeviceUtil
import kotlinx.android.synthetic.main.activity_sms_received.*

class SmsReceivedActivity : Activity() {

    private val FULL_SCREEN_FLAG = (
            View.SYSTEM_UI_FLAG_LAYOUT_STABLE
                    or View.SYSTEM_UI_FLAG_LAYOUT_HIDE_NAVIGATION
                    or View.SYSTEM_UI_FLAG_HIDE_NAVIGATION
                    or View.SYSTEM_UI_FLAG_IMMERSIVE_STICKY
                    or View.SYSTEM_UI_FLAG_FULLSCREEN)

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        setContentView(R.layout.activity_sms_received)

        //Constants.smsCheck = false

        setFinishOnTouchOutside(false)
        //window.decorView.systemUiVisibility = FULL_SCREEN_FLAG

        tv_sms_reply.movementMethod = ScrollingMovementMethod.getInstance()

        val address = intent.getStringExtra("address")
        val data = intent.getStringExtra("sms_data")

        tv_sms_title.text = "SMS from: " + address
        tv_sms_reply.text = data

        //提取手机号
        //val regex = "((13[0-9])|(14[5|7])|(15([0-3]|[5-9]))|(18[0-9]))\\d{8}"
        val regex = "(1[3-9][0-9])\\d{8}"
        val phone = AppUtils.getMobileNumber(data, regex)
        edit_sms_phone.setText(phone)


        btn_number_cancel.setOnClickListener {
            Constants.smsCheck = false
            finish()
        }

        btn_number_confirm.setOnClickListener {
            Constants.smsCheck = false
            val phoneNo = edit_sms_phone.text.toString()
            if (!TextUtils.isEmpty(phoneNo)) {
                val tcpModel = DeviceUtil.deviceConnect2(Constants.Companion.imei, phoneNo)
                NettyClient.instance.sendMsg(tcpModel.toJson()).subscribe {
                    if (it) {
                        showMessage(R.string.device_number_update_success)
                    } else {
                        showMessage(R.string.device_number_update_failed)
                    }
                }
                finish()
            } else {
                showMessage(R.string.device_number_update_empty)
            }
        }
    }
}