package com.wdkl.ncs.android.component.home.adapter

import android.content.Context
import android.view.ViewGroup
import com.alibaba.android.vlayout.LayoutHelper
import com.alibaba.android.vlayout.layout.LinearLayoutHelper
import com.wdkl.ncs.android.component.home.R
import com.wdkl.ncs.android.component.home.databinding.UpdateContactItemBinding
import com.wdkl.ncs.android.lib.adapter.BaseDelegateAdapter
import com.wdkl.ncs.android.lib.utils.BaseRecyclerViewHolder

class ContactUpdateAdapter(val data: ArrayList<String>, val context: Context):
    BaseDelegateAdapter<BaseRecyclerViewHolder<UpdateContactItemBinding>, String>() {

    override fun dataProvider(): Any {
        return data
    }

    override fun itemFilter(position: Int): Boolean {
        return true
    }

    override fun onCreateViewHolder(
        p0: ViewGroup,
        p1: Int
    ): BaseRecyclerViewHolder<UpdateContactItemBinding> {
        return BaseRecyclerViewHolder.build(p0, R.layout.update_contact_item)
    }

    override fun onBindViewHolder(p0: BaseRecyclerViewHolder<UpdateContactItemBinding>, p1: Int) {
        p0.bind {
            binding ->
            binding.tvContactItem.text = data[p1]
        }
    }

    override fun getItemCount(): Int {
        return data.size
    }

    override fun onCreateLayoutHelper(): LayoutHelper {
        return LinearLayoutHelper(0, data.size)
    }

}