package com.wdkl.ncs.android.component.home.broadcast

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.util.Log
import android.view.KeyEvent
import com.wdkl.ncs.android.middleware.common.Constants
import com.wdkl.ncs.android.lib.vo.MessageEvent
import org.greenrobot.eventbus.EventBus

class MyMediaButtonReceiver: BroadcastReceiver() {
    var TAG = "MyMediaButtonReceiver"
    override fun onReceive(context: Context?, intent: Intent?) {
        val action = intent!!.action
        if (action!=null&&action.equals(Intent.ACTION_MEDIA_BUTTON)){
            var keyEvent = intent!!.getParcelableExtra<KeyEvent>(Intent.EXTRA_KEY_EVENT)
            if (keyEvent!=null && keyEvent.action == KeyEvent.ACTION_DOWN){
                val keyCode = keyEvent.keyCode
                Log.i(TAG, "keyCode " + keyCode)
                when (keyCode){
                    KeyEvent.KEYCODE_MEDIA_PLAY -> {
                        EventBus.getDefault().post(MessageEvent(1, Constants.EVENT_BLUETOOTH_ACCEPT_CALL))
                        return
                    }
                    KeyEvent.KEYCODE_MEDIA_PAUSE -> {
                        EventBus.getDefault().post(MessageEvent(1, Constants.EVENT_BLUETOOTH_ACCEPT_CALL))
                        return
                    }
                }
            }
        }
    }
}