package com.wdkl.ncs.android.component.home.entity;

import com.wdkl.ncs.android.component.home.search.IAZItem;
import com.wdkl.ncs.android.component.home.search.IFuzzySearchItem;

import java.util.List;

public class ContactItemEntity implements IAZItem, IFuzzySearchItem {

    private String       mValue;
    private String       mNumber;
    private int          mId;
    private String       mSortLetters;
    private List<String> mFuzzySearchKey;

    public ContactItemEntity(String value, String number, int id, String sortLetters, List<String> fuzzySearchKey) {
        mValue = value;
        mNumber = number;
        mId = id;
        mSortLetters = sortLetters;
        mFuzzySearchKey = fuzzySearchKey;
    }

    public String getValue() {
        return mValue;
    }

    public String getNumber() {
        return mNumber;
    }

    public int getId() {
        return mId;
    }

    @Override
    public String getSortLetters() {
        return mSortLetters;
    }

    @Override
    public String getSourceKey() {
        return mValue;
    }

    @Override
    public List<String> getFuzzyKey() {
        return mFuzzySearchKey;
    }
}
