package com.wdkl.ncs.android.component.home.util;

import android.annotation.SuppressLint;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.text.TextUtils;
import android.util.Log;

import com.wdkl.ncs.android.component.home.activity.WatchHome2Activity;
import com.wdkl.ncs.android.lib.base.BaseApplication;
import com.wdkl.ncs.keepbackground.work.DaemonEnv;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class AppUtils {

    public static void restartApp() {
        //DaemonEnv.sendStopWorkBroadcast(BaseApplication.appContext);
        try {
            Log.i("AppUtil", "restartApp ======================");
            Intent intent = new Intent(BaseApplication.appContext, WatchHome2Activity.class);
            @SuppressLint("WrongConstant") PendingIntent mPendingIntent = PendingIntent.getActivity(
                    BaseApplication.appContext, 0, intent,
                    Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TOP);
            AlarmManager mgr = (AlarmManager) BaseApplication.appContext.getSystemService(Context.ALARM_SERVICE);
            mgr.set(AlarmManager.RTC, System.currentTimeMillis() + 1500, mPendingIntent);
        } catch (Exception e) {
            e.printStackTrace();
        }

        android.os.Process.killProcess(android.os.Process.myPid());
        System.exit(0);
    }

    /**
     * 提取手机号码
     * 移动号段:   134 135 136 137 138 139 147 148 150 151 152 157 158 159  165 172 178 182 183 184 187 188 198
     * 联通号段:   130 131 132 145 146 155 156 166 170 171 175 176 185 186
     * 电信号段:   133 149 153 170 173 174 177 180 181 189  191  199
     * 虚拟运营商: 170
     */
    public static String getMobileNumber(String str, String reg){
        if (TextUtils.isEmpty(str)) {
            return "";
        }

        // 将给定的正则表达式编译到模式中
        Pattern pattern = Pattern.compile(reg);
        // 创建匹配给定输入与此模式的匹配器。
        Matcher matcher = pattern.matcher(str);
        //查找字符串中是否有符合的子字符串
        if(matcher.find()){
            //查找到符合的即输出
            //Log.e("sms", "getMobileNumber: " + matcher.group());
            return matcher.group();
        }

        return "";
    }

    public static boolean checkMobileNumber(String str, String reg){
        if (TextUtils.isEmpty(str)) {
            return false;
        }

        // 将给定的正则表达式编译到模式中
        Pattern pattern = Pattern.compile(reg);
        // 创建匹配给定输入与此模式的匹配器。
        Matcher matcher = pattern.matcher(str);
        //查找字符串中是否有符合的子字符串
        return matcher.find();
    }
}
