package com.wdkl.ncs.android.component.home.util;

import android.app.Activity;
import android.app.AlertDialog;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;

import com.wdkl.ncs.android.component.home.R;


public class IMDialogHelper {

    private static AlertDialog imDialog;

    public static void showIMDialog(Activity activity) {
        if (imDialog != null && imDialog.isShowing()) {
            return;
        }

        View contentView = LayoutInflater.from(activity).inflate(R.layout.im_dialog_lay, null);
        AlertDialog.Builder builder = new AlertDialog.Builder(activity);
        builder.setView(contentView);

        Button confirm = contentView.findViewById(R.id.btn_im_confirm);
        confirm.setOnClickListener(v -> {
            RecordHelper.getInstance().stopCancelRecordByOther(false);
            dismissIMDialog();
        });


        imDialog = builder.create();
        imDialog.setCanceledOnTouchOutside(false);
        imDialog.setCancelable(false);

        //设置dialog宽高及位置
        try {
            Window window = imDialog.getWindow();
            window.setFlags(WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE, WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE);
            imDialog.show();
            WindowManager.LayoutParams lp = window.getAttributes();
            lp.width = WindowManager.LayoutParams.MATCH_PARENT;
            lp.height = WindowManager.LayoutParams.WRAP_CONTENT;
            lp.gravity = Gravity.CENTER;
            //lp.alpha = 0.8f;//设置透明度
            window.setAttributes(lp);

            window.clearFlags(WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void dismissIMDialog() {
        if (imDialog != null) {
            imDialog.dismiss();
            imDialog = null;
        }
    }
}
