package com.wdkl.app.ncs.application

//import android.content.Context
import android.content.Context
import android.content.res.Configuration
import com.enation.javashop.android.jrouter.JRouter
import com.enation.javashop.net.engine.config.NetEngineConfig
import com.enation.javashop.net.engine.plugin.exception.RestfulExceptionInterceptor
import com.enation.javashop.utils.base.config.BaseConfig
import com.wdkl.ncs.android.component.home.settingconfig.SettingConfig
import com.wdkl.ncs.android.component.home.util.LocaleMangerUtils
import com.wdkl.ncs.android.lib.base.BaseApplication
//import me.weishu.reflection.Reflection

/**
 * @author LDD
 * @Date   2018/1/11 下午12:48
 * @From   com.enation.javashop.android.application
 * @Note   应用Application
 */
class Application : BaseApplication() {


    /**
     * @author LDD
     * @From   Application
     * @Date   2018/1/11 下午12:50
     * @Note   应用启动时调用
     */
    override fun onCreate() {
        super.onCreate()

        initRouter()
        initFrame()
        initLeaks()
    }

    /**
     * @author  LDD
     * @From    Application
     * @Date   2018/1/11 下午12:50
     * @Note   初始化路由
     * @return rx观察者
     */
    private fun initRouter() {
        JRouter.init(this)
        JRouter.openDebug()
        JRouter.openLog()
        JRouter.prepare().create("/home/launch").seek()
    }

    /**
     * @author  LDD
     * @From    Application
     * @Date   2018/1/11 下午12:50
     * @Note   初始化内存检测器
     * @return rx观察者
     */
    private fun initLeaks() {
    }

    /**
     * @author  LDD
     * @From    Application
     * @Date   2018/1/11 下午12:50
     * @Note   初始化内部框架
     * @return rx观察者
     */
    private fun initFrame() {
        //禁止滑掉退出
        BaseConfig.getInstance().addActivity("WatchHome2Activity", "NewEventListActivity", "AppUpdateActivity", "NetworkCheckActivity", "ContactUpdateActivity")

        NetEngineConfig.init(baseContext)
                .openLogger()
                .addNetInterceptor(RestfulExceptionInterceptor())
    }

    override fun attachBaseContext(base: Context?) {
        val languageId: Int = SettingConfig.getLanguageId(base)
        LocaleMangerUtils.setApplicationLanguageByIndex(base, languageId)
        super.attachBaseContext(base)
    }

    override fun onConfigurationChanged(newConfig: Configuration) {
        super.onConfigurationChanged(newConfig)
        val languageId: Int = SettingConfig.getLanguageId(baseContext)
        LocaleMangerUtils.setApplicationLanguageByIndex(baseContext, languageId)
    }
}