package com.wdkl.ncs.android.middleware.api

import io.reactivex.Observable
import okhttp3.MultipartBody
import okhttp3.ResponseBody
import retrofit2.http.*

interface WatchManageDeviceApi {
    @POST("/watch/getWatchContacts")
    fun getWatchContacts(@Query("page_no") pageNo: Int,
                         @Query("device_id") deviceId: Int,
                         @Query("page_size") pageSize: Int= ApiManager.PAGE_SIZE): Observable<ResponseBody>


    //获取APP版本信息
    @POST("/watch/getAppVersion")
    fun getAppVersion(@Query("part_id") part_id:Int, @Query("device_type") device_type:Int): Observable<ResponseBody>

    //上传文件
    @Multipart
    @POST("/ncs/upload/file")
    fun uploadFile(@Part() file : MultipartBody.Part) :Observable<ResponseBody>

    //获取频道消息列表
    @POST("/watch/channelim/page")
    fun getChannelImList(@Query("page_no") page_no:Int, @Query("page_size") page_size:Int, @Query("member_id") member_id:Int, @Query("channel_id") channel_id:Int): Observable<ResponseBody>

    @GET("/watch/getPhoneNumberWhiteList/{deviceId}")
    fun getPhoneWhiteList(@Path("deviceId") deviceId:Int): Observable<ResponseBody>

    //获取通讯录
    @GET("/watch/getWatchContacts/{deviceId}")
    fun getWatchContactList(@Path("deviceId") deviceId:Int): Observable<ResponseBody>

    @GET("/watch/clerk_list_by_interctaion_id/{interactionId}")
    fun getClerks(@Path("interactionId") interactionId:Int): Observable<ResponseBody>

    @PUT("/watch/interaction/{id}")
    fun updateInteraction(@Path("id") id: Int,
                          @Query("actionEndMemberId") actionEndMemberId: Int): Observable<ResponseBody>
}