package com.wdkl.ncs.android.middleware.logic.contract.home

import com.wdkl.ncs.android.lib.base.BaseContract
import com.wdkl.ncs.android.middleware.model.ServerIpInfo
import com.wdkl.ncs.android.middleware.model.dos.AppVersionDO
import com.wdkl.ncs.android.middleware.model.dos.ChannelDO
import com.wdkl.ncs.android.middleware.model.dos.DeviceDO
import com.wdkl.ncs.android.middleware.model.dos.PartSettingDO
import com.wdkl.ncs.android.middleware.model.dto.TcpSeverDTO
import com.wdkl.ncs.android.middleware.model.vo.DeviceVO
import com.wdkl.ncs.android.middleware.model.vo.WatchContactVO
import com.wdkl.ncs.android.middleware.model.vo.WatchContactsVO

interface WatchHomeActivityContract{
    interface View : BaseContract.BaseView{
        //版本号信息
        fun handleAppVersion(appInfo: AppVersionDO)
        //显示设备信息
        fun setDeviceDo(data : DeviceVO)
        //显示tcp通讯地址
        fun setTcpServerHost(tcpSeverDTO: TcpSeverDTO)
        //设置服务器配置数据
        fun setServerInfo(serverIpInfo: ServerIpInfo)
        //设置设备设置数据
        fun setDeviceSettingData(partSettingDO: PartSettingDO)
        //语音频道列表
        fun setDeviceVoiceChannel(channelList: ArrayList<ChannelDO>)
        //手机号码白名单
        fun setPhoneNumberWhiteList(phoneList: ArrayList<String>)
        //设置通讯录
        fun setContact(contactsVOs: List<WatchContactVO>)
    }
    interface Presenter : BaseContract.BasePresenter{
        //获取版本信息
        fun getAppVersion(partId: Int, deviceType: Int)
        //获取设备信息
        fun getDeviceVO(ethMac:String)
        //获取tcp服务器地址
        fun getTcpServerHost()
        //获取服务器配置
        fun getServerInfo()
        //获取设备设置数据
        fun getDeviceSettingData(partId:Int)
        //获取该设备语音频道列表
        fun getDeviceVoiceChannel(memberId: Int)
        //获取手机号码白名单
        fun getPhoneNumberWhiteList(deviceId: Int)
        //获取通讯录
        fun getWatchContacts(deviceId: Int)
    }
}