package com.wdkl.ncs.android.middleware.model.dos;

import com.fasterxml.jackson.databind.PropertyNamingStrategy;
import com.fasterxml.jackson.databind.annotation.JsonNaming;
import com.wdkl.ncs.android.middleware.model.annotation.Column;
import com.wdkl.ncs.android.middleware.model.annotation.Id;
import com.wdkl.ncs.android.middleware.model.annotation.PrimaryKeyField;
import com.wdkl.ncs.android.middleware.model.annotation.Table;

import java.io.Serializable;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

@Table(name = "ncs_channel_im")
@ApiModel
@JsonNaming(value = PropertyNamingStrategy.SnakeCaseStrategy.class)
public class ChannelImDO implements Serializable {

    /**
     * 消息id
     */
    @Column(name = "id")
    @ApiModelProperty(value = "消息id", required = false)
    @Id(name = "id")
    private Integer id;
    /**
     * null
     */
    @Column(name = "union_id")
    @ApiModelProperty(value = "null", required = false)
    private String unionId;
    /**
     * null
     */
    @Column(name = "create_time")
    @ApiModelProperty(value = "null", required = false)
    private Long createTime;
    /**
     * 频道Id
     */
    @Column(name = "channel_id")
    @ApiModelProperty(value = "频道Id", required = false)
    private Integer channelId;
    /**
     * 发送者id
     */
    @Column(name = "sender_member_id")
    @ApiModelProperty(value = "发送者id", required = false)
    private Integer senderMemberId;
    /**
     * 发送者姓名
     */
    @Column(name = "sender_member_name")
    @ApiModelProperty(value = "发送者姓名", required = false)
    private String senderMemberName;
    /**
     * 发送时间
     */
    @Column(name = "send_time")
    @ApiModelProperty(value = "发送时间", required = false)
    private Long sendTime;
    /**
     * 音频文件路径
     */
    @Column(name = "audio_path")
    @ApiModelProperty(value = "音频文件路径", required = false)
    private String audioPath;


    @PrimaryKeyField
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }


    public String getUnionId() {
        return unionId;
    }

    public void setUnionId(String unionId) {
        this.unionId = unionId;
    }


    public Long getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Long createTime) {
        this.createTime = createTime;
    }


    public Integer getChannelId() {
        return channelId;
    }

    public void setChannelId(Integer channelId) {
        this.channelId = channelId;
    }


    public Integer getSenderMemberId() {
        return senderMemberId;
    }

    public void setSenderMemberId(Integer senderMemberId) {
        this.senderMemberId = senderMemberId;
    }


    public String getSenderMemberName() {
        return senderMemberName;
    }

    public void setSenderMemberName(String senderMemberName) {
        this.senderMemberName = senderMemberName;
    }


    public Long getSendTime() {
        return sendTime;
    }

    public void setSendTime(Long sendTime) {
        this.sendTime = sendTime;
    }


    public String getAudioPath() {
        return audioPath;
    }

    public void setAudioPath(String audioPath) {
        this.audioPath = audioPath;
    }

}
