package com.wdkl.ncs.android.middleware.model.dos;

import com.fasterxml.jackson.databind.PropertyNamingStrategy;
import com.fasterxml.jackson.databind.annotation.JsonNaming;
import com.wdkl.ncs.android.middleware.model.annotation.Column;
import com.wdkl.ncs.android.middleware.model.annotation.Id;
import com.wdkl.ncs.android.middleware.model.annotation.PrimaryKeyField;
import com.wdkl.ncs.android.middleware.model.annotation.Table;

import java.io.Serializable;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

@Table(name = "ncs_channel_im_readed")
@ApiModel
@JsonNaming(value = PropertyNamingStrategy.SnakeCaseStrategy.class)
public class ChannelImReadedDO implements Serializable {

    /**
     * 消息读取状态记录id
     */
    @Column(name = "id")
    @ApiModelProperty(value = "消息读取状态记录id", required = false)
    @Id(name = "id")
    private Integer id;
    /**
     * null
     */
    @Column(name = "union_id")
    @ApiModelProperty(value = "null", required = false)
    private String unionId;
    /**
     * null
     */
    @Column(name = "create_time")
    @ApiModelProperty(value = "null", required = false)
    private Long createTime;
    /**
     * 频道消息Id
     */
    @Column(name = "channel_im_id")
    @ApiModelProperty(value = "频道消息Id", required = false)
    private Integer channelImId;

    /**
     * 频道Id
     */
    @Column(name = "channel_id")
    @ApiModelProperty(value = "频道Id", required = false)
    private Integer channelId;

    /**
     * 订阅用户Id
     */
    @Column(name = "member_id")
    @ApiModelProperty(value = "订阅用户Id", required = false)
    private Integer memberId;
    /**
     * 播放时间
     */
    @Column(name = "read_time")
    @ApiModelProperty(value = "播放时间", required = false)
    private Long readTime;


    @PrimaryKeyField
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }


    public String getUnionId() {
        return unionId;
    }

    public void setUnionId(String unionId) {
        this.unionId = unionId;
    }


    public Long getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Long createTime) {
        this.createTime = createTime;
    }


    public Integer getChannelImId() {
        return channelImId;
    }

    public void setChannelImId(Integer channelImId) {
        this.channelImId = channelImId;
    }


    public Integer getMemberId() {
        return memberId;
    }

    public void setMemberId(Integer memberId) {
        this.memberId = memberId;
    }


    public Long getReadTime() {
        return readTime;
    }

    public void setReadTime(Long readTime) {
        this.readTime = readTime;
    }

    public Integer getChannelId() {
        return channelId;
    }

    public void setChannelId(Integer channelId) {
        this.channelId = channelId;
    }
}
