package com.wdkl.ncs.android.middleware.tcp.channel;

import android.os.Build;

import com.wdkl.ncs.android.lib.base.BaseApplication;
import com.wdkl.ncs.android.middleware.BuildConfig;
import com.wdkl.ncs.android.middleware.common.Constants;
import com.wdkl.ncs.android.middleware.tcp.dto.DeviceConnectDTO;
import com.wdkl.ncs.android.middleware.tcp.dto.TcpModel;
import com.wdkl.ncs.android.middleware.tcp.enums.TcpAction;
import com.wdkl.ncs.android.middleware.tcp.enums.TcpType;
import com.wdkl.ncs.android.middleware.utils.CommonUtils;
import com.wdkl.ncs.android.middleware.utils.ContactHelper;

public class DeviceUtil {
    public static TcpModel deviceConnect(String mac){
        DeviceConnectDTO deviceConnectDTO = new DeviceConnectDTO();
        deviceConnectDTO.setIdentification(mac);
        deviceConnectDTO.setModel(Build.MODEL);
        deviceConnectDTO.setSoftware_version("V" + CommonUtils.getAppVersionName(BaseApplication.appContext));
        deviceConnectDTO.setHardware_version(Build.HARDWARE);
        deviceConnectDTO.setCode(Constants.Companion.getImei());
        deviceConnectDTO.setPhoneNumber(ContactHelper.getPhoneNumber());
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.DEVICE);
        tcpModel.setAction(TcpAction.DeviceAction.CONNECT);
        tcpModel.setData(deviceConnectDTO);
        return tcpModel;
    }

    public static TcpModel deviceConnect2(String mac, String phoneNumber){
        DeviceConnectDTO deviceConnectDTO = new DeviceConnectDTO();
        deviceConnectDTO.setIdentification(mac);
        deviceConnectDTO.setModel(Build.MODEL);
        deviceConnectDTO.setSoftware_version("V"+CommonUtils.getAppVersionName(BaseApplication.appContext));
        deviceConnectDTO.setHardware_version(Build.HARDWARE);
        deviceConnectDTO.setCode(Constants.Companion.getImei());
        deviceConnectDTO.setPhoneNumber(phoneNumber);
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.DEVICE);
        tcpModel.setAction(TcpAction.DeviceAction.CONNECT);
        tcpModel.setData(deviceConnectDTO);
        return tcpModel;
    }

    public static TcpModel userChange(Integer fromId){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.DEVICE);
        tcpModel.setAction(TcpAction.DeviceAction.USER_CHANGE);
        tcpModel.setFromId(fromId);
        return tcpModel;
    }

    public static TcpModel deviceChange(Integer fromId, Integer toId){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.DEVICE);
        tcpModel.setAction(TcpAction.DeviceAction.DEVICE_CHANGE);
        tcpModel.setFromId(fromId);
        tcpModel.setToId(toId);
        return tcpModel;
    }
}
