package com.wdkl.ncs.android.middleware.tcp.channel;

import com.wdkl.ncs.android.middleware.model.vo.InteractionVO;
import com.wdkl.ncs.android.middleware.tcp.dto.TcpModel;
import com.wdkl.ncs.android.middleware.tcp.enums.TcpAction;
import com.wdkl.ncs.android.middleware.tcp.enums.TcpType;

public class PhoneUtil {

    //电话呼出
    public static TcpModel phoneCall(Integer fromId, Integer toId){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.PHONE);
        tcpModel.setAction(TcpAction.PhoneAction.CALL);
        tcpModel.setFromId(fromId);
        tcpModel.setToId(toId);
        return tcpModel;
    }

    //电话取消
    public static TcpModel phoneCancel(Integer fromId){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.PHONE);
        tcpModel.setAction(TcpAction.PhoneAction.CANCEL);
        tcpModel.setFromId(fromId);
        return tcpModel;
    }

    //电话接听
    public static TcpModel phoneAccept(Integer fromId, InteractionVO interactionVO){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.PHONE);
        tcpModel.setAction(TcpAction.PhoneAction.ACCEPT);
        tcpModel.setFromId(fromId);
        tcpModel.setData(interactionVO);
        return tcpModel;
    }

    //电话拒接
    public static TcpModel phoneReject(Integer fromId){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.PHONE);
        tcpModel.setAction(TcpAction.PhoneAction.REJECT);
        tcpModel.setFromId(fromId);
        return tcpModel;
    }

    //电话挂断
    public static TcpModel phoneHandoff(Integer fromId, InteractionVO interactionVO){
        TcpModel tcpModel = new TcpModel();
        tcpModel.setType(TcpType.PHONE);
        tcpModel.setAction(TcpAction.PhoneAction.HANDOFF);
        tcpModel.setFromId(fromId);
        tcpModel.setData(interactionVO);
        return tcpModel;
    }
}
