package com.wdkl.ncs.android.middleware.tcp.enums;

/**
 * @author wuyunfeng
 * 2021-12-19 14:48
 * 通话方式枚举
 */
public enum CommunicationEnum {

    NET_WORK(1, "网络电话"),
    MOBILE_PHONE(2, "移动电话卡"),
    TELEPHONE(3, "固定电话");

    private int value;
    private String typeName;


    CommunicationEnum(int value, String typeName) {
        this.value = value;
        this.typeName = typeName;
    }

    public int value() {
        return this.value;
    }

    public String typeName() {
        return this.typeName;
    }

    /**
     * 通过typeName 转换成枚举
     *
     * @param typeName
     * @return
     */
    public static CommunicationEnum parse(String typeName) {
        CommunicationEnum[] values = CommunicationEnum.values();
        for (CommunicationEnum value : values) {
            if (value.typeName().equals(typeName)) {
                return value;
            }
        }
        return null;
    }

    /**
     * 通过value值转换成枚举
     *
     * @param value
     * @return
     */
    public static CommunicationEnum parse(int value) {
        CommunicationEnum[] values = CommunicationEnum.values();
        for (CommunicationEnum communicationEnum : values) {
            if (communicationEnum.value() == value) {
                return communicationEnum;
            }
        }
        return null;
    }

}
